/* ADC test program */

#include <stdio.h>
#include "i2c.h"
#include "adc.h"
#include "simpletools.h"

int main(void)
{
    int i;
    int adcAddr;
    I2C *bus;
    
#if 0  
  
    if (!(bus = i2cBootOpen())) {
        printf("error: can't open boot i2c bus\n");
        return 1;
    }
        
    /* check for the AD7993BRUZ-0 chip */
    if (DetectAdcChip(bus, AD7993BRUZ_0) == 0) {
        printf("AD7993BRUZ-0 found\n");
        adcAddr = AD7993BRUZ_0;
    }
    
    /* check for the AD7993BRUZ-1 chip */
    else if (DetectAdcChip(bus, AD7993BRUZ_1) == 0) {
        printf("AD7993BRUZ-1 found\n");
        adcAddr = AD7993BRUZ_1;
    }
    
    /* no adc chip found */
    else {
        printf("error: no adc chip found\n");
        return 1;
    }
        
    for (i=0; i < 10; i++) {
        printf("%c", HOME);          // clear
        printf("adc[0] = %g\n", adcVolts(bus, adcAddr, 0));
       // printf("adc[1] = %g\n", adcVolts(bus, adcAddr, 1));
       // printf("adc[2] = %g\n", adcVolts(bus, adcAddr, 2));
        usleep(1000000);
    }
    
#else

    uint16_t  buffer[3*16];
    ADC       adc, *dev;
    uint16_t  newVal[2];
    uint16_t  oldVal = 0;
    
    if (!(dev = adcOpen(&adc, 28, 29, AD7993BRUZ_0, 7, 10000, buffer, 3*16))) {
        printf("error: can't open adc device\n");
        return 1;
    }
    
    for (;;)  {
        uint16_t buf[3];
        printf("%c", HOME);          // clear
        adcRead(dev, newVal, 1);
        if (newVal[0] = oldVal) {
          printf("adc[0] = %d   old: %d",newVal[0] & 0xfff,oldVal);
          oldVal = newVal[0];
        }
        //printf("adc[%d] = %d\n", (buf[1] >> 12) & 3, buf[1] & 0x0fff);
        //printf("adc[%d] = %d\n", (buf[2] >> 12) & 3, buf[2] & 0x0fff);
        usleep(100000);
        //printf("oPtr %04x, iPtr %04x\n", dev->state.mailbox.oPtr, dev->state.mailbox.iPtr);
    }
    
#endif
    
    return 0;
}

